

















DATABASE catcom

{#define PA_REC         RECORD             lorange LIKE extranges.lorange,             hirange LIKE extranges.hirange,             code1 LIKE extranges.code1,             code2 LIKE extranges.code2,             codedesc LIKE extranges.codedesc         END RECORD
}



GLOBALS
    DEFINE
        pa_extrange_save RECORD             lorange integer,             hirange integer,             code1 char(3),             code2 char(2),             codedesc char(20)         END RECORD,
	pa_extranges ARRAY[10000] OF RECORD             lorange integer,             hirange integer,             code1 char(3),             code2 char(2),             codedesc char(20)         END RECORD,
	siteform_open SMALLINT,
        update_flag SMALLINT,
        changes_made SMALLINT,
        idx, i, screen_idx, total_idx, scr_ln INTEGER,
	answer		char(1),
	fgltext1	CHAR(80),
	msg1		CHAR(256)
    DEFINE input_siteid SMALLINT
    DEFINE sitecode CHAR(4)
END GLOBALS 

MAIN
    CLEAR SCREEN
    DEFER INTERRUPT
    DEFER QUIT

    --#CALL fgl_init4js()

{! # A4GL !}
{#!  IF a4gl_get_ui_mode() > 0 then !}
{#!      # send default config file to gui !}
{#!      IF aclfgl_sendfile_to_ui("default_vdc.4ad") THEN END IF !}
{#!      IF aclfgl_sendfile_to_ui("default_vdc.4st") THEN END IF !}
{#!      CALL ui.Interface.loadActionDefaults("default") !}
{#!      CALL ui.Interface.loadStyles("default") !}
{#!      CALL ui.Interface.setText("Extension Ranges") !}
{#!	CALL fgl_dialog_setkeylabel("f7", "Pick From List") !}
{##!	CALL fgl_winmessage("a4gl_get_ui_mode() code run") !}
{#!  END IF !}

    OPTIONS
        PROMPT LINE LAST,
        MESSAGE LINE LAST - 1,
	INSERT KEY CONTROL-O,
	DELETE KEY CONTROL-U,
	NEXT KEY CONTROL-N,
	PREVIOUS KEY CONTROL-P,
        FORM LINE 1

    LET siteform_open = FALSE
    LET changes_made = 0
    CALL prepare_window ()

    CLEAR SCREEN

END MAIN




FUNCTION input_site()
    DEFINE
        pr_extranges RECORD LIKE extranges.*,
        sitename LIKE site.sitenm1
    DEFINE answer CHAR(1)

    LET update_flag = FALSE

    IF siteform_open = FALSE THEN
	    OPEN FORM extsite FROM "extsite"
	    DISPLAY FORM extsite

	    {DISPLAY " Site " AT 4, 2 ATTRIBUTE ( REVERSE )}

            LET siteform_open = TRUE
    END IF


    INPUT BY NAME pr_extranges.siteid

        ON KEY (INTERRUPT)
	    LET int_flag = FALSE
            EXIT INPUT

	#works ON KEY (F7)
	#ON KEY (CONTROL-F)
	ON KEY (F7)
		LET int_flag = FALSE

		IF infield(siteid) THEN
			CALL get_siteid_wind() RETURNING pr_extranges.siteid
			IF int_flag THEN
				LET pr_extranges.siteid = get_fldbuf(siteid)
			END IF
			LET sitename = get_sitename(pr_extranges.siteid)
			DISPLAY BY NAME pr_extranges.siteid, sitename
			LET int_flag = FALSE
		END IF

        AFTER FIELD siteid 
	    IF NOT siteid_exist(pr_extranges.siteid) THEN
                LET pr_extranges.siteid = get_siteid_wind() 
                NEXT FIELD siteid
            END IF
            LET sitename = get_sitename(pr_extranges.siteid)
	    DISPLAY BY NAME sitename
 
    END INPUT

{
    IF update_flag THEN
        RUN "unload -dcatcom -textranges -f/tmp/ext_tmp"
        CALL que_allnode_download("/tmp/ext_tmp", "extranges")
    END IF
}

    RETURN pr_extranges.siteid

END FUNCTION

FUNCTION prepare_window ()

    LET input_siteid = NULL

    OPEN WINDOW menuwin AT 2, 2
	WITH 22 ROWS, 78 COLUMNS
	ATTRIBUTE ( BORDER, FORM LINE 3, MESSAGE LINE LAST )

    LET sitecode = fgl_getenv("DIREC_SITE")
    IF length(sitecode) > 0 THEN
	SELECT siteid INTO input_siteid FROM site WHERE sitenm1[1,4] = sitecode
    END IF
	
    IF input_siteid IS NOT NULL THEN
	CALL input_range_array ( input_siteid )
    ELSE
	    MENU "Extension Range"
		COMMAND "Site" "Input Site id"
			CALL input_site () RETURNING input_siteid
			NEXT OPTION "Ranges"
		COMMAND "Ranges" "Extension Ranges input"
			CALL input_range_array ( input_siteid )
		COMMAND "Exit" "Exit"
			EXIT MENU
	    END MENU
    END IF

    CLOSE WINDOW menuwin

END FUNCTION


FUNCTION input_range_array(input_siteid)

    DEFINE
        input_siteid LIKE extranges.siteid,
	action CHAR(1),
        cont_loop SMALLINT,
	extr_code_hdr CHAR(32)

    IF input_siteid IS NULL THEN
	MESSAGE "A particular site must be selected first" ATTRIBUTE ( REVERSE )
	SLEEP 2
	MESSAGE ""
        RETURN
    END IF	

    OPEN WINDOW extrngwin AT 8, 5
	WITH 15 ROWS, 70 COLUMNS
	ATTRIBUTES ( BORDER, MESSAGE LINE LAST )

    OPEN FORM extrng FROM "extrng"
    DISPLAY FORM extrng


    DISPLAY " Extension Range " AT 1, 2 ATTRIBUTE (REVERSE)
    --# if fgl_fglgui() = 0 then
	    DISPLAY "Insert Ctrl-O" AT 1, 30 ATTRIBUTE (NORMAL)
    --# end if
    DISPLAY "Delete Ctrl-U" AT 1, 46 ATTRIBUTE (NORMAL)

    LET extr_code_hdr = fgl_getenv("EXTR_CODE_HDR")
    IF length(extr_code_hdr) > 0 THEN
    	DISPLAY extr_code_hdr AT 2, 33
    END IF

    DECLARE range_list CURSOR FOR
    SELECT lorange, hirange, code1, code2, codedesc
        FROM extranges
        WHERE siteid = input_siteid
        ORDER BY lorange

    
    FOR idx = 1 TO 10000
        INITIALIZE pa_extranges[idx].* TO NULL
    END FOR

    LET total_idx = 1
    FOREACH range_list INTO pa_extranges[total_idx].*
        LET total_idx = total_idx + 1
        IF total_idx > 10000 THEN
            ERROR "Could Not Display All Extension Ranges"
            EXIT FOREACH
        END IF
    END FOREACH
    LET total_idx = total_idx - 1

    LET changes_made = 0

    CALL set_count(total_idx)
    LET cont_loop = TRUE
    WHILE cont_loop

	CALL SET_COUNT(10000)
	INPUT ARRAY pa_extranges WITHOUT DEFAULTS FROM sa_extranges.*

        ON KEY (INTERRUPT)
	    LET int_flag = FALSE
	    LET quit_flag = FALSE
	    IF changes_made THEN
		LET fgltext1 = "All changes will be lost, Continue with Abort"
		LET answer = fglwinyn("Extranges", fgltext1 clipped)
	    ELSE
		let answer = "Y"
	    END IF
	    if ( int_flag ) or ( quit_flag ) or ( answer not matches "[Yy]" )
	    then
		# Don't abort
	        LET int_flag = FALSE
	        LET quit_flag = FALSE
	    else
	        LET int_flag = TRUE
	        LET quit_flag = FALSE
		LET cont_loop = FALSE
		MESSAGE "Aborting..."
		EXIT INPUT
	    end iF

        BEFORE ROW
	    #prompt "got to beginning of code in BEFORE ROW" FOR CHAR action
	    LET idx = arr_curr()
	    LET screen_idx = scr_line()
	    #prompt "got to end of code in BEFORE ROW" FOR CHAR action

        AFTER ROW
	    #prompt "got to beginning of code in AFTER ROW" FOR CHAR action
	    DISPLAY pa_extranges[idx].* TO 
	    	sa_extranges[screen_idx].*
	    #    ATTRIBUTE ( NORMAL )
	    #prompt "got to end of code in AFTER ROW" FOR CHAR action

        BEFORE FIELD lorange        
            LET idx = arr_curr()
            LET total_idx = arr_count()
            IF pa_extranges[idx].lorange IS NOT NULL AND
              pa_extranges[idx].hirange IS NOT NULL THEN
		    DISPLAY pa_extranges[idx].lorange TO 
			sa_extranges[screen_idx].lorange
			ATTRIBUTE ( REVERSE, BLINK )
		    DISPLAY pa_extranges[idx].hirange TO 
			sa_extranges[screen_idx].hirange
			ATTRIBUTE ( REVERSE )
	    END IF
	    LET pa_extrange_save.lorange = pa_extranges[idx].lorange

        AFTER FIELD lorange        
            LET idx = arr_curr()
            LET total_idx = arr_count()
            IF NOT valid_range(pa_extranges[idx].lorange, idx, total_idx) THEN
                 ERROR "Cannot enter range that already exists"
                 NEXT FIELD lorange
            END IF
	    IF pa_extrange_save.lorange != pa_extranges[idx].lorange THEN

	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.lorange IS NULL AND
	       pa_extranges[idx].lorange IS NOT NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.lorange IS NOT NULL AND
	       pa_extranges[idx].lorange IS NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.lorange IS NOT NULL AND
	       pa_extranges[idx].lorange IS NOT NULL AND
	       pa_extrange_save.lorange != pa_extranges[idx].lorange
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF


        BEFORE FIELD hirange
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    DISPLAY pa_extranges[idx].lorange TO 
		sa_extranges[screen_idx].lorange
		ATTRIBUTE ( REVERSE )
	    DISPLAY pa_extranges[idx].hirange TO 
		sa_extranges[screen_idx].hirange
		ATTRIBUTE ( REVERSE, BLINK )
	    LET pa_extrange_save.hirange = pa_extranges[idx].hirange

        AFTER FIELD hirange        
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    IF (pa_extranges[idx].hirange IS NULL AND 
			pa_extranges[idx].lorange IS NOT NULL ) THEN
		ERROR "Value is required in this field"
		NEXT FIELD hirange
	    END IF
            IF (pa_extranges[idx].lorange > pa_extranges[idx].hirange) THEN
                ERROR "Cannot Enter a hirange lower than the lorange"
                NEXT FIELD hirange
            END IF
            IF NOT valid_range(pa_extranges[idx].hirange, idx, total_idx) THEN
                ERROR "Cannot enter range that already exists"
                NEXT FIELD hirange
            END IF
	    IF pa_extrange_save.hirange IS NULL AND
	       pa_extranges[idx].hirange IS NOT NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.hirange IS NOT NULL AND
	       pa_extranges[idx].hirange IS NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.hirange IS NOT NULL AND
	       pa_extranges[idx].hirange IS NOT NULL AND
	       pa_extrange_save.hirange != pa_extranges[idx].hirange
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF


        BEFORE FIELD code1
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    LET pa_extrange_save.code1 = pa_extranges[idx].code1

	AFTER FIELD code1        
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    IF pa_extrange_save.code1 IS NULL AND
	       pa_extranges[idx].code1 IS NOT NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.code1 IS NOT NULL AND
	       pa_extranges[idx].code1 IS NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.code1 IS NOT NULL AND
	       pa_extranges[idx].code1 IS NOT NULL AND
	       pa_extrange_save.code1 != pa_extranges[idx].code1
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF


        BEFORE FIELD code2
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    LET pa_extrange_save.code2 = pa_extranges[idx].code2

        AFTER FIELD code2        
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    IF pa_extrange_save.code2 IS NULL AND
	       pa_extranges[idx].code2 IS NOT NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.code2 IS NOT NULL AND
	       pa_extranges[idx].code2 IS NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.code2 IS NOT NULL AND
	       pa_extranges[idx].code2 IS NOT NULL AND
	       pa_extrange_save.code2 != pa_extranges[idx].code2
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF


        BEFORE FIELD codedesc
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    LET pa_extrange_save.codedesc = pa_extranges[idx].codedesc

        AFTER FIELD codedesc        
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    IF pa_extrange_save.codedesc IS NULL AND
	       pa_extranges[idx].codedesc IS NOT NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.codedesc IS NOT NULL AND
	       pa_extranges[idx].codedesc IS NULL
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF
	    IF pa_extrange_save.codedesc IS NOT NULL AND
	       pa_extranges[idx].codedesc IS NOT NULL AND
	       pa_extrange_save.codedesc != pa_extranges[idx].codedesc
	    THEN
	    		LET changes_made = changes_made + 1
	    END IF


       BEFORE INSERT
            LET idx = arr_curr()
            LET total_idx = arr_count()
	    LET scr_ln = scr_line()

		#LET msg1 = "idx = ", idx, "   total_idx = ", total_idx,
		#	"  scr_line = ", scr_ln
		#CALL fglwinmsg("info", msg1, "info")

	AFTER INSERT
	    LET changes_made = changes_made + 1


	BEFORE DELETE
	    DISPLAY pa_extranges[idx].* TO sa_extranges[screen_idx].*
		        ATTRIBUTE ( REVERSE )
	    IF pa_extranges[idx].lorange IS NOT NULL THEN
			MESSAGE "Deleting Record ..." 
			SLEEP 1
	    END IF

	AFTER DELETE
		LET changes_made = changes_made + 1

        AFTER INPUT
            LET idx = arr_curr()
            LET total_idx = arr_count()
            IF NOT valid_range(pa_extranges[idx].lorange, idx, total_idx) THEN
                 ERROR "Cannot enter range that already exists"
                 NEXT FIELD lorange
            END IF
	    IF (pa_extranges[idx].hirange IS NULL AND 
			pa_extranges[idx].lorange IS NOT NULL ) THEN
		ERROR "Value is required in this field"
		NEXT FIELD hirange
	    END IF
            IF (pa_extranges[idx].lorange > pa_extranges[idx].hirange) THEN
                ERROR "Cannot Enter a hirange lower than the lorange"
                NEXT FIELD hirange
            END IF
            IF NOT valid_range(pa_extranges[idx].hirange, idx, total_idx) THEN
                ERROR "Cannot enter range that already exists"
                NEXT FIELD hirange
            END IF

	    # OK.
            CALL confirm_action() RETURNING action
	    CASE action
	       WHEN "C"
		    DISPLAY pa_extranges[idx].* TO sa_extranges[screen_idx].*
		    ATTRIBUTE ( NORMAL )
               WHEN "Q"
                    LET cont_loop = FALSE
		    EXIT INPUT
	    END CASE
    END INPUT

    END WHILE

    IF NOT int_flag AND changes_made > 0 THEN
	    CALL save_changes()
    END IF

    LET int_flag = 0

    CLOSE FORM extrng
    CLOSE WINDOW extrngwin

END FUNCTION


FUNCTION valid_range(input_range, current_idx, total_idx)
    DEFINE
        input_range LIKE extranges.lorange,
        current_idx SMALLINT,
        total_idx SMALLINT,
        i SMALLINT

   

   IF input_range = 0 THEN
	RETURN (TRUE)
   END IF

   FOR i = 1 TO total_idx
       IF i != current_idx THEN
           IF input_range >= pa_extranges[i].lorange
               AND input_range <= pa_extranges[i].hirange THEN
               RETURN (FALSE)
           END IF
       END IF
   END FOR   

   RETURN (TRUE)
END FUNCTION

{
Function returns TRUE if user answers "Y or y" 
         returns FALSE if user answers "N or n"
}
FUNCTION YesNo (promptstring)

DEFINE 
	promptstring CHAR(50),
	answer CHAR(1)

	WHILE TRUE
		Prompt promptstring CLIPPED FOR answer
		IF answer MATCHES "[Yy]" THEN
			RETURN TRUE
		ELSE IF answer MATCHES "[Nn]" THEN
			RETURN FALSE
		     ELSE MESSAGE "Y or N please"
			  SLEEP 1
		     END IF
                END IF
	END WHILE

END FUNCTION
	

FUNCTION confirm_action ()

DEFINE action CHAR(1)

	LET int_flag = FALSE
	LET quit_flag = FALSE
	OPEN WINDOW bottomwindow AT 17, 7
		WITH 2 ROWS, 28 COLUMNS

	MENU "  Option" 
		COMMAND "Continue" "  Continue from current row"
			LET action = "C"
			EXIT MENU
		COMMAND "Exit" "  Exit"
			LET action = "Q"
			EXIT MENU
	END MENU

        CLOSE WINDOW bottomwindow

	RETURN action

END FUNCTION

{
 redisplay record after delete or insert
}

FUNCTION redisplay_rec ()

DEFINE
	curr_idx, total_idx, curr_scr, total_scr, idx SMALLINT

	LET curr_idx = arr_curr()
	LET total_idx = arr_count ()
	LET curr_scr = scr_line ()
	LET total_scr = 10

	FOR idx = curr_idx TO total_idx
{	LET pa_extranges[idx].* = pa_extranges[idx+1].* }
		IF curr_scr <= total_scr THEN
			Display pa_extranges[idx].* TO
				sa_extranges[curr_scr].*  ATTRIBUTE (NORMAL)
			LET curr_scr = curr_scr + 1
		END IF
	END FOR

END FUNCTION


FUNCTION save_changes()

	LET fgltext1 = "Save Changes"
	LET int_flag = FALSE
	LET quit_flag = FALSE
	LET answer = fglwinyn("Extranges", fgltext1 clipped)
	if ( int_flag ) or ( quit_flag ) or ( answer not matches "[Yy]" )
	then
		# Don't save
		MESSAGE "Changes Not Saved"
	else
		DELETE FROM extranges
		WHERE siteid = input_siteid
		FOR idx = 1 TO total_idx
			IF pa_extranges[idx].lorange IS NOT NULL THEN
				INSERT INTO extranges
				VALUES ( input_siteid,
					 pa_extranges[idx].lorange,
					 pa_extranges[idx].hirange,
					 pa_extranges[idx].code1,
					 pa_extranges[idx].code2,
					 pa_extranges[idx].codedesc
					)
			END IF
		END FOR
		MESSAGE "Changes Saved"
	end if
	    
END FUNCTION

